/*
 *  Copyright (C) 2004 by Digital Mars, www.digitalmars.com
 *  Written by Lynn Allan by adapting code by Walter Bright
 *
 *  This software is provided 'as-is', without any express or implied
 *  warranty. In no event will the authors be held liable for any damages
 *  arising from the use of this software.
 *
 *  Permission is granted to anyone to use this software for any purpose,
 *  including commercial applications, and to alter it and redistribute it
 *  freely, subject to the following restrictions:
 *
 *  o  The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *  o  Altered source versions must be plainly marked as such, and must not
 *     be misrepresented as being the original software.
 *  o  This notice may not be removed or altered from any source
 *     distribution.
 */

module std.c.windows.windows_tree;

private import std.c.windows.windows;

extern (Windows)
{
export int InitCommonControls();
/*
 * TreeControl Flags
 */
alias HANDLE HTREEITEM;

enum
{
TV_FIRST                = 0x1100,      // TreeView messages
TVN_FIRST               = (0U-400U),   // treeview
TVN_LAST                = (0U-499U),

TVS_HASBUTTONS          = 0x0001,
TVS_HASLINES            = 0x0002,
TVS_LINESATROOT         = 0x0004,
TVS_EDITLABELS          = 0x0008,
TVS_DISABLEDRAGDROP     = 0x0010,
TVS_SHOWSELALWAYS       = 0x0020,
TVS_RTLREADING          = 0x0040,
TVS_NOTOOLTIPS          = 0x0080,
TVS_CHECKBOXES          = 0x0100,
TVS_TRACKSELECT         = 0x0200,
TVS_SINGLEEXPAND        = 0x0400,
TVS_INFOTIP             = 0x0800,
TVS_FULLROWSELECT       = 0x1000,
TVS_NOSCROLL            = 0x2000,
TVS_NONEVENHEIGHT       = 0x4000,

TVIF_TEXT               = 0x0001,
TVIF_IMAGE              = 0x0002,
TVIF_PARAM              = 0x0004,
TVIF_STATE              = 0x0008,
TVIF_HANDLE             = 0x0010,
TVIF_SELECTEDIMAGE      = 0x0020,
TVIF_CHILDREN           = 0x0040,
TVIF_INTEGRAL           = 0x0080,
TVIS_SELECTED           = 0x0002,
TVIS_CUT                = 0x0004,
TVIS_DROPHILITED        = 0x0008,
TVIS_BOLD               = 0x0010,
TVIS_EXPANDED           = 0x0020,
TVIS_EXPANDEDONCE       = 0x0040,
TVIS_EXPANDPARTIAL      = 0x0080,

TVIS_OVERLAYMASK        = 0x0F00,
TVIS_STATEIMAGEMASK     = 0xF000,
TVIS_USERMASK           = 0xF000,

TVI_ROOT                = (cast(int)0xFFFF0000),
TVI_FIRST               = (cast(int)0xFFFF0001),
TVI_LAST                = (cast(int)0xFFFF0002),
TVI_SORT                = (cast(int)0xFFFF0003),

TVM_INSERTITEMA         = (TV_FIRST + 0),
TVM_INSERTITEMW         = (TV_FIRST + 50),
TVM_INSERTITEM          = TVM_INSERTITEMA,

TVM_DELETEITEM          = (TV_FIRST + 1),
TVM_EXPAND              = (TV_FIRST + 2),
TVE_COLLAPSE            = 0x0001,
TVE_EXPAND              = 0x0002,
TVE_TOGGLE              = 0x0003,
TVE_EXPANDPARTIAL       = 0x4000,
TVE_COLLAPSERESET       = 0x8000,
TVM_GETITEMRECT         = (TV_FIRST + 4),
TVM_GETCOUNT            = (TV_FIRST + 5),
TVM_GETINDENT           = (TV_FIRST + 6),
TVM_SETINDENT           = (TV_FIRST + 7),
TVM_GETIMAGELIST        = (TV_FIRST + 8),
TVSIL_NORMAL            = 0,
TVSIL_STATE             = 2,
TVM_SETIMAGELIST        = (TV_FIRST + 9),
TVM_GETNEXTITEM         = (TV_FIRST + 10),
TVGN_ROOT               = 0x0000,
TVGN_NEXT               = 0x0001,
TVGN_PREVIOUS           = 0x0002,
TVGN_PARENT             = 0x0003,
TVGN_CHILD              = 0x0004,
TVGN_FIRSTVISIBLE       = 0x0005,
TVGN_NEXTVISIBLE        = 0x0006,
TVGN_PREVIOUSVISIBLE    = 0x0007,
TVGN_DROPHILITE         = 0x0008,
TVGN_CARET              = 0x0009,
TVGN_LASTVISIBLE        = 0x000A,
TVM_SELECTITEM          = (TV_FIRST + 11),
TVM_GETITEMA            = (TV_FIRST + 12),
TVM_GETITEMW            = (TV_FIRST + 62),
TVM_GETITEM             = TVM_GETITEMA,
TVM_SETITEMA            = (TV_FIRST + 13),
TVM_SETITEMW            = (TV_FIRST + 63),
TVM_SETITEM             = TVM_SETITEMA,
TVM_EDITLABELA          = (TV_FIRST + 14),
TVM_EDITLABELW          = (TV_FIRST + 65),
TVM_EDITLABEL           = TVM_EDITLABELA,
TVM_GETEDITCONTROL      = (TV_FIRST + 15),
TVM_GETVISIBLECOUNT     = (TV_FIRST + 16),
TVM_HITTEST             = (TV_FIRST + 17),
TVHT_NOWHERE            = 0x0001,
TVHT_ONITEMICON         = 0x0002,
TVHT_ONITEMLABEL        = 0x0004,
TVHT_ONITEMINDENT       = 0x0008,
TVHT_ONITEMBUTTON       = 0x0010,
TVHT_ONITEMRIGHT        = 0x0020,
TVHT_ONITEMSTATEICON    = 0x0040,
TVHT_ONITEM             = (TVHT_ONITEMICON | TVHT_ONITEMLABEL | TVHT_ONITEMSTATEICON),
TVHT_ABOVE              = 0x0100,
TVHT_BELOW              = 0x0200,
TVHT_TORIGHT            = 0x0400,
TVHT_TOLEFT             = 0x0800,
TVM_CREATEDRAGIMAGE     = (TV_FIRST + 18),
TVM_SORTCHILDREN        = (TV_FIRST + 19),
TVM_ENSUREVISIBLE       = (TV_FIRST + 20),
TVM_SORTCHILDRENCB      = (TV_FIRST + 21),
TVM_ENDEDITLABELNOW     = (TV_FIRST + 22),
TVM_GETISEARCHSTRINGA   = (TV_FIRST + 23),
TVM_GETISEARCHSTRINGW   = (TV_FIRST + 64),
TVM_GETISEARCHSTRING    = TVM_GETISEARCHSTRINGA,
TVM_SETTOOLTIPS         = (TV_FIRST + 24),
TVM_GETTOOLTIPS         = (TV_FIRST + 25),
TVM_SETINSERTMARK       = (TV_FIRST + 26),
TVM_SETITEMHEIGHT       = (TV_FIRST + 27),
TVM_GETITEMHEIGHT       = (TV_FIRST + 28),
TVM_SETBKCOLOR          = (TV_FIRST + 29),
TVM_SETTEXTCOLOR        = (TV_FIRST + 30),
TVM_GETBKCOLOR          = (TV_FIRST + 31),
TVM_GETTEXTCOLOR        = (TV_FIRST + 32),
TVM_SETSCROLLTIME       = (TV_FIRST + 33),
TVM_GETSCROLLTIME       = (TV_FIRST + 34),
TVM_SETINSERTMARKCOLOR  = (TV_FIRST + 37),
TVM_GETINSERTMARKCOLOR  = (TV_FIRST + 38),
TVN_SELCHANGINGA        = (TVN_FIRST-1),
TVN_SELCHANGINGW        = (TVN_FIRST-50),
TVN_SELCHANGEDA         = (TVN_FIRST-2),
TVN_SELCHANGEDW         = (TVN_FIRST-51),

TVC_UNKNOWN             = 0x0000,
TVC_BYMOUSE             = 0x0001,
TVC_BYKEYBOARD          = 0x0002,

TVN_GETDISPINFOA        = (TVN_FIRST-3),
TVN_GETDISPINFOW        = (TVN_FIRST-52),
TVN_SETDISPINFOA        = (TVN_FIRST-4),
TVN_SETDISPINFOW        = (TVN_FIRST-53),
TVIF_DI_SETITEM         = 0x1000,
TVN_ITEMEXPANDINGA      = (TVN_FIRST-5),
TVN_ITEMEXPANDINGW      = (TVN_FIRST-54),
TVN_ITEMEXPANDEDA       = (TVN_FIRST-6),
TVN_ITEMEXPANDEDW       = (TVN_FIRST-55),
TVN_BEGINDRAGA          = (TVN_FIRST-7),
TVN_BEGINDRAGW          = (TVN_FIRST-56),
TVN_BEGINRDRAGA         = (TVN_FIRST-8),
TVN_BEGINRDRAGW         = (TVN_FIRST-57),
TVN_DELETEITEMA         = (TVN_FIRST-9),
TVN_DELETEITEMW         = (TVN_FIRST-58),
TVN_BEGINLABELEDITA     = (TVN_FIRST-10),
TVN_BEGINLABELEDITW     = (TVN_FIRST-59),
TVN_ENDLABELEDITA       = (TVN_FIRST-11),
TVN_ENDLABELEDITW       = (TVN_FIRST-60),
TVN_KEYDOWN             = (TVN_FIRST-12),

TVN_GETINFOTIPA         = (TVN_FIRST-13),
TVN_GETINFOTIPW         = (TVN_FIRST-14),
TVN_SINGLEEXPAND        = (TVN_FIRST-15),

TVN_SELCHANGING         = TVN_SELCHANGINGA,
TVN_SELCHANGED          = TVN_SELCHANGEDA,
TVN_GETDISPINFO         = TVN_GETDISPINFOA,
TVN_SETDISPINFO         = TVN_SETDISPINFOA,
TVN_ITEMEXPANDING       = TVN_ITEMEXPANDINGA,
TVN_ITEMEXPANDED        = TVN_ITEMEXPANDEDA,
TVN_BEGINDRAG           = TVN_BEGINDRAGA,
TVN_BEGINRDRAG          = TVN_BEGINRDRAGA,
TVN_DELETEITEM          = TVN_DELETEITEMA,
TVN_BEGINLABELEDIT      = TVN_BEGINLABELEDITA,
TVN_ENDLABELEDIT        = TVN_ENDLABELEDITA,

TVN_GETINFOTIP          = TVN_GETINFOTIPA,
TVCDRF_NOIMAGES         = 0x00010000,
}

struct TVITEMA {
    UINT      mask;
    HTREEITEM hItem;
    UINT      state;
    UINT      stateMask;
    LPSTR     pszText;
    int       cchTextMax;
    int       iImage;
    int       iSelectedImage;
    int       cChildren;
    LPARAM    lParam;
}
alias TVITEMA *LPTVITEMA;
alias TVITEMA TV_ITEMA;

struct TVINSERTSTRUCTA {
    HTREEITEM hParent;
    HTREEITEM hInsertAfter;
    TV_ITEMA item;
} 
alias TVINSERTSTRUCTA *LPTVINSERTSTRUCTA;
alias TVINSERTSTRUCTA *LPTV_INSERTSTRUCTA;
alias TVINSERTSTRUCTA TV_INSERTSTRUCTA;

struct NMHDRA {
    UINT  hwndFrom;
    UINT  idFrom;
    UINT  code;
} 
alias NMHDRA *LPNMHDRA;
alias NMHDRA *LP_NMHDRA;

struct NMTREEVIEWA {
    NMHDRA     hdr;
    UINT       action;
    TVITEMA    itemOld;
    TVITEMA    itemNew;
    POINT      ptDrag;
}
alias NMTREEVIEWA *LPNMTREEVIEWA;
alias NMTREEVIEWA *LP_NMTREEVIEW;

}
